unit SharedObjectU;

interface

uses
  Classes, SysUtils;

type
  TSharedObject = class {$ifDef production}refcounted{$endif}
  public
    constructor Create;
    function CheckDebugTrackingEnabled: Boolean;
    destructor Destroy; override;
  end;

implementation

constructor TSharedObject.Create;
begin
  inherited Create;
  if CheckDebugTrackingEnabled then
    WriteLN('Constructing ' + ClassName);
end;

function TSharedObject.CheckDebugTrackingEnabled: Boolean;
begin
  result := True;
end;

destructor TSharedObject.Destroy;
begin
  if CheckDebugTrackingEnabled then
    WriteLN('Destroying ' + ClassName);
  inherited Destroy;
end;

end.

